package ru.themixray.puton;

import org.bukkit.Bukkit;
import org.bukkit.command.*;
import org.bukkit.command.defaults.BukkitCommand;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;
import ru.themixray.puton.command.BootsCommand;
import ru.themixray.puton.command.ChestplateCommand;
import ru.themixray.puton.command.HelmetCommand;
import ru.themixray.puton.command.LeggingsCommand;
import ru.themixray.puton.listener.SwapItemListener;
import ru.themixray.puton.util.UnrealConfig;

import java.lang.reflect.Field;
import java.util.List;

public final class Main extends JavaPlugin implements Listener {
    public void onEnable() {
        Config.loadConfig(new UnrealConfig(this, getDataFolder(), "config.yml"));
        Bukkit.getPluginManager().registerEvents(new SwapItemListener(), this);
        registerCommand(Config.HELMET_COMMANDS, "Puts on item from your hand as helmet", new HelmetCommand());
        registerCommand(Config.CHESTPLATE_COMMANDS, "Puts on item from your hand as chestplate", new ChestplateCommand());
        registerCommand(Config.LEGGINGS_COMMANDS, "Puts on item from your hand as leggings", new LeggingsCommand());
        registerCommand(Config.BOOTS_COMMANDS, "Puts on item from your hand as boots", new BootsCommand());
    }

    public CommandMap getCommandMap() {
        try {
            Field bukkitCommandMap = Bukkit.getServer().getClass().getDeclaredField("commandMap");
            bukkitCommandMap.setAccessible(true);
            return (CommandMap) bukkitCommandMap.get(Bukkit.getServer());
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public void registerCommand(List<String> names, String description, CommandExecutor executor) {
        if (names.isEmpty()) {
            return;
        }
        BukkitCommand command = new BukkitCommand(
            names.get(0),
            description,
            "/"+names.get(0),
            names.subList(1, names.size())
        ) {
            @Override
            public boolean execute(CommandSender sender, String alias, String[] args) {
                return executor.onCommand(sender, this, alias, args);
            }

            @Override
            public List<String> tabComplete(CommandSender a, String b, String[] c) throws IllegalArgumentException {
                return List.of();
            }
        };
        getCommandMap().register(names.get(0), command);
    }
}